/*
 * test.c - test ciphers ...
 *
 * hackbard@hackdaworld.dyndns.org
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "des.h"

#define LEN 32

int main() {
 u8 plain[LEN];
 u8 crypted[LEN];
 u8 plain_new[LEN];
 u8 key[8];
 int fd,i;

 if((fd=open("/dev/urandom",O_RDONLY))<0) {
  puts("open urandom device failed!");
  return fd;
 }

 printf("des crypt/decrypt test:\n");
 printf("- generating simple/random key ...\n");
 read(fd,key,8);
 printf("key: ");
 for(i=0;i<8;i++) printf("%02x ",key[i]);
 puts("");

 memset(plain,0,LEN);
 strcpy(plain,"allyourbase");
 printf("encrypting '%s' \n",plain);
 
 printf("ecb mode:\n");
 memset(crypted,0,LEN);
 des_encrypt(plain,crypted,key,LEN,MODE_ECB);
 printf("plain: ");
 for(i=0;i<LEN;i++) printf("%02x ",plain[i]);
 puts("");
 printf("crypted: ");
 for(i=0;i<LEN;i++) printf("%02x ",crypted[i]);
 puts("");
 des_decrypt(crypted,plain_new,key,LEN,MODE_ECB);
 printf("new plain: ");
 for(i=0;i<LEN;i++) printf("%02x ",plain[i]);
 puts("");
 if(!strcmp(plain,plain_new)) printf("looks good!\n");

 printf("cbc mode:\n");
 memset(crypted,0,LEN);
 memset(plain_new,0,LEN);
 printf("plain: ");
 for(i=0;i<LEN;i++) printf("%02x ",plain[i]);
 puts("");
 des_encrypt(plain,crypted,key,LEN,MODE_CBC);

 /* test */
 printf("plain: ");
 for(i=0;i<LEN;i++) printf("%02x ",plain[i]);
 puts("");
 /* test end */

 printf("crypted: ");
 for(i=0;i<LEN;i++) printf("%02x ",crypted[i]);
 puts("");
 des_decrypt(crypted,plain_new,key,LEN,MODE_CBC);
 printf("new plain: ");
 for(i=0;i<LEN;i++) printf("%02x ",plain[i]);
 puts("");
 if(!strcmp(plain,plain_new)) printf("looks good!\n");
 
 close(fd);

 puts("done :)");

 return 1;
}
